unit laby;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    plan: TImage;
    procedure FormCreate(Sender: TObject);
    procedure planMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);


    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Button1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure planDblClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;


var
 larg:integer;
 haut:integer;
  Form1: TForm1;
  fini:boolean;
  tab: array[0..200,0..200] of shortint;
  i,j,tx,ty,mx,my:integer;
implementation

{$R *.DFM}

function  trouve(x,y:integer):tpoint;
  var i,k,a,b:integer;
      mem:array[0..4] of tpoint;
  begin
  k:=0  ;
  for i:=0 to 3  do
  begin
  a:=round(x+cos(Pi/2*i));
  b:=round(y+sin(Pi/2*i));
  if (a>0) and (b>0) and (a<larg+1) and (b<haut+1) and (tab[a,b]<>1) then
  begin
  mem[k].x:=a;
  mem[k].y:=b;
  k:=k+1;
  end;
  end;
  if k=0 then
  begin
  result.x:=1000;
  result.y:=1000;
  end
  else result:=mem[random(k)];
end;
procedure recur(x,y:integer);
var po:tpoint;
begin
with form1 do begin
po:=trouve(x,y);
while po.x<500 do
begin

tab[po.x,po.y]:=1;
plan.refresh;
recur(po.x,po.y);
plan.canvas.moveto(10*x,10*y);
plan.canvas.lineto(10*po.x,10*po.y);
po:=trouve(x,y);
end;
end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var i,j:integer;
begin
fini:=false;
randomize;
form1.windowstate:=wsmaximized;
form1.refresh;
larg:=trunc(screen.width/10)-1;
haut:=trunc(screen.height/10)-1;
tx:=1;
ty:=1;
mx:=10;
my:=10;
plan.width:=larg*10+8;
plan.height:=haut*10+8;
for i:=0 to larg do
 for j:=0 to haut do
 begin
 tab[i,j]:=0;
 end;
 tab[10,10]:=1;
plan.canvas.brush.color:=clblack;
plan.canvas.pen.color:=clwhite;
plan.canvas.rectangle(0,0,800,800);
plan.canvas.pen.width:=7;
recur(10,10);
plan.canvas.moveto(10*larg,10*haut);
plan.canvas.pen.color:=clred;
plan.canvas.lineto(10*larg,10*haut);
end;
function test(u,v,w,z:integer): boolean;
var a,b:integer;
begin
result:=true;
if ((u<>w )and( v<>z)) or (abs(w-u)>1) or (abs(z-v)>1)then
begin
result:=false;
exit;
end;
a:=round(10*(u+w)/2);
b:=round(10*(v+z)/2);

result:=(form1.plan.canvas.pixels[a,b]<>clblack);
end;

procedure TForm1.planMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var i,j:integer ;
  begin
if fini then exit;
i:=trunc((x+5)/10);
j:=trunc((y+5)/10);
if test(tx,ty,i,j) then
begin
if plan.canvas.pixels[x,y]=clred then
begin
fini:=true;
showmessage('Enfin !,C''est fini vous tes libre !');
application.terminate;
end;
tx:=i;
ty:=j;
mx:=x;
my:=y;
end
else mouse_event(MOUSEEVENTF_MOVE,mx-x,my-y ,0,0)


end;

procedure TForm1.Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
if fini then exit;
mouse_event(MOUSEEVENTF_MOVE,(plan.left+mx)-x,(plan.top+my)-y ,0,0)
end;



procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
 canclose:=false;
end;

procedure TForm1.Button1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
if fini then exit;
mouse_event(MOUSEEVENTF_MOVE,(plan.left+mx)-x,(plan.top+my)-y ,0,0)
end;

procedure TForm1.planDblClick(Sender: TObject);
begin
APPLICATION.TERMINATE;
end;

end.
